C**********************************************************                  CBADJ.2     
C             SUBROUTINE CBADJ                                               CBADJ.3     
C**********************************************************                  CBADJ.4     
      SUBROUTINE CBADJ(NCRB,NCRT,J,IHEM)                                     CBADJ.5     
C                                                                            CBADJ.6     
C     PRECIPITATING DEEP CONVECTION SCHEME.                                  CBADJ.7     
C     ADJUSTMENT TOWARDS A SUBSATURATED MOIST ADIABAT.                       CBADJ.8     
C                                                                            CBADJ.9     
C                                                                            PARAM1.2     
C     Determines model resolution                                            PARAM1.3     
C                                                                            PARAM1.4     
      PARAMETER(NN=21,MM=21,NHEM=2,NL=5,MOCT=1,MG=64,JG=16,NWJ2=121          NETCDF.35    
     P         ,NCRAY=64,JGL=JG,NTRAC=1,NLEVRF=1)                            NETCDF.36    
                                                                             PARAM1.7     
C                                                                            PARAM1.8     
C                                                                            PARAM2.2     
C     Sets basic constants, especially those needed for array dimensions     PARAM2.3     
C                                                                            PARAM2.4     
      PARAMETER(MH=2,PI=3.14159265359,PI2=2.0*PI                             PARAM2.5     
     +,NNP=NN+1,MGPP=MG+2,JGP=JG+1,JGG=JG*NHEM,JGGP=JGG+1,MJP=NWJ2+NWJ2      PARAM2.6     
     +,NLM=NL-1,NLP=NL+1,NLPP=NL+2,NLA=NL+3,NLB=NL+4,NL2=NL*NL               PARAM2.7     
     +,IDA=(MG+MG+MG)/2+1,IDB=NWJ2*NL,IDC=IDB+IDB,IDD=MGPP*NL                PARAM2.8     
     +,IDE=NL2*NN,IDF=NCRAY*(MG+1),IDG=JG*NL,IDH=JG*MG                       PARAM2.9     
     +,IDI=NNP/2,IDJ=IDI*IDI,IDK=NL*IDI,IDL=MGPP/2,IDM=NNP/2,IDN=IDM*NL      PARAM2.10    
     +,NWW=1+(MM-1)/MOCT)                                                    PARAM2.11    
      PARAMETER(IGA=NWJ2*NHEM,IGB=IDB*NHEM,IGC=MGPP*NHEM,IGD=IDD*NHEM        PARAM2.12    
     +,IGG=IDG*NHEM,IGL=IDL*NHEM,IGM=IDM*NHEM,IGN=IDN*NHEM                   PARAM2.13    
     +,IGO=IGA+IGA,IGP=IGB+IGB,NFTWG=(5+NTRAC)*NL+3                          PARAM2.14    
     +,NFTGW=(6+3*NTRAC)*NL+2,NFTGD=(3+NTRAC)*NL,NLTR=NL*NTRAC)              PARAM2.15    
C     Number of 2D (surface) output fields. This value is                    PARAM2.16    
C     Doubled due to averaged and instantaneous fields.                      PARAM2.17    
      PARAMETER (N2DFLD=21,NGRPAD=N2DFLD*2*IGC)                              PARAM2.18    
C                                                                            PARAM2.19    
C                                                                            BLANK.2     
C     Basic planetary parameters for run plus information about              BLANK.3     
C     vertical grid structure                                                BLANK.4     
C                                                                            BLANK.5     
C     Note that RD and GASCON are identical and CPD is set from RD,AKAP.     BLANK.6     
      COMMON        SQ(NNP),RSQ(NNP),SIGMAH(NLM),SIGMA(NL)                   BLANK.7     
     +              ,T01S2(NLM),T0(NL),ALPHA(NL),DSIGMA(NL),RDSIG(NL)        BLANK.8     
     +              ,TKP(NL),C(NL2),SQH(NNP)                                 BLANK.9     
     +              ,MF,MFP,JZF,NF,NFP                                       BLANK.10    
     +              ,AKAP,GA,GASCON,RADEA,WW,P0,PFAC,EZ,AIOCT                BLANK.11    
     +              ,RD,RV,CPD,CLATNT                                        BLANK.12    
     +              ,LRSTRT,LSHORT,LTVEC,LSTRETCH                            BLANK.13    
     +              ,LFLUX                                                   BLANK.14    
     +              ,LBALAN,LRESTIJ                                          BLANK.15    
     +              ,LCLIM, LPERPET, L22L,LOROG ,LCSFCT                      BLANK.16    
     +              ,LNOISE                                                  BLANK.17    
      COMPLEX EZ,AIOCT                                                       BLANK.18    
      LOGICAL LRSTRT,LSHORT,LTVEC,LSTRETCH,LBALAN,LRESTIJ                    BLANK.19    
     +       ,LFLUX,LNOISE                                                   BLANK.20    
     +       ,LCLIM, LPERPET, L22L,LOROG,LCSFCT                              BLANK.21    
C                                                                            BLANK.22    
C                                                                            LEGAU.2     
C     Legendre polynomials and information about gaussian latitudes          LEGAU.3     
C                                                                            LEGAU.4     
      COMMON/LEGAU/ ALPJ(MJP),DALPJ(MJP)                                     LEGAU.5     
     +              ,ALP(NWJ2,2,JGL),DALP(NWJ2,2,JGL)                        LEGAU.6     
     +              ,RLP(NWJ2,2,JGL),RDLP(NWJ2,2,JGL)                        LEGAU.7     
     +              ,SI(JGG),CS(JGG),SISQ(JGG),CSSQ(JGG),SECSQ(JGG)          LEGAU.8     
     +              ,ALAT(JGG),GWT(JGG),AW(JGG),JH,JL,JINC                   LEGAU.9     
C                                                                            LEGAU.10    
C                                                                            GRIDPP.2     
C     Array ordering in GRIDP must correspond to that in SPECTR.             GRIDPP.3     
C     Real arrays: multi-level arrays are 2-dimensional.                     GRIDPP.4     
C     the variables have been renamed to coincide with                       GRIDPP.5     
C     variable names in bgcm5 DGRMLT                                         GRIDPP.6     
C                                                                            GRIDPP.7     
C swapped round VLNG and UNLG to check                                       GRIDPP.8     
      COMMON/GRIDP/ CHIG(IGC,NL),SFG(IGC,NL),UG(IGC,NL),VG(IGC,NL)           GRIDPP.9     
     :              ,TTVD(IGC,NL),QTVD(IGC,NL),TG(IGC,NL)                    GRIDPP.10    
     :              ,TRAG(IGC,NL,NTRAC)                                      GRIDPP.11    
     :              ,PLG(IGC),TYBL(IGC),TXBL(IGC)                            GRIDPP.12    
     :              ,SPG(IGC),VPG(IGC),TTRD(IGC,NL)                          GRIDPP.13    
     :              ,TNLG(IGC,NL),TRANLG(IGC,NL,NTRAC),UNLG(IGC,NL)          GRIDPP.14    
     :              ,VNLG(IGC,NL),TTLR(IGC,NL),UTRAG(IGC,NL,NTRAC)           GRIDPP.15    
     :              ,TTCR(IGC,NL),VTRAG(IGC,NL,NTRAC)                        GRIDPP.16    
     :              ,UTVD(IGC,NL),VTVD(IGC,NL)                               GRIDPP.17    
     :         ,ASSBL(IGC),ASHBL(IGC),ASLBL(IGC),ARRCR(IGC),ARRLR(IGC)       GRIDPP.18    
     :         ,arflux(igc,6),asfld(igc,6),acld(igc,4)                       GRIDPP.19    
     :         ,SSBL(IGC),SHBL(IGC),SLBL(IGC),RRCR(IGC),RRLR(IGC)            GRIDPP.20    
     :         ,rflux(igc,6),sfld(igc,6),cld(igc,4)                          GRIDPP.21    
C                                                                            GRIDPP.22    
      COMMON/PHYS/  LBL,LVD,LCR,LLR,LRD,LCUBM,LCBADJ                         PHYSCA.2     
     :              ,TSTAR(IGC,JG),QSTAR(IGC,JG),FRAD(JG,NHEM)               PHYSCA.3     
     :              ,TSTARO(IGC,JG),TDEEPO(IGC,JG),smstar(igc,jg)            PHYSCA.4     
     :              ,tdeep(igc,jg),hsnow(igc,jg),sqstar(igc,jg)              PHYSCA.5     
     :              ,SALB(IGC,JG),SBAL(IGC,JG),BLCD(IGC)                     PHYSCA.6     
     :              ,SVEGE(IGC,JG),CD,DRAG,BLVAD,BLA,BLRH,BLVB(IGC)          PHYSCA.7     
     :              ,AKVV,AKTV,AKQV,ESCONA,ESCONB,EPSIQ,CTQ,CCC              PHYSCA.8     
     : ,ctqi,sdsn,shcs,shcsp,shcsn,skse,sksn,slhf,sd1,sd2,sdw                PHYSCA.9     
     :        ,ssmc,sdsnd,LSL,sasnow,saice,shsstar,shsmax                    PHYSCA.10    
     :     ,LOC,SHCO,SHCI,LNOICE,LOLDBL,LCOND,LNNSK,ITSLL,ITSLO              PHYSCA.11    
     :              ,CCR,RCON,DTBUOY,TSLA,TSLB,TSLC,TSLD,CUT1,CUT2           PHYSCA.12    
     :              ,NLCR,NCUTOP,CURHM,AKTC,AKQC,CUBMT,CBADJT,CBADJP         PHYSCA.13    
     :              ,SKAP(NL),SK(NLM),FWS(NL),CLR(NL),FB(NLM)                PHYSCA.14    
     :              ,TTDC(NL),QTDC(NL),TTMC(NL),QTMC(NL),TC(NL),QC(NL)       PHYSCA.15    
     :              ,CTCR(NL,NHEM),CTLR(NL,NHEM),NAVRD,NAVWT,DELT2C          PHYSCA.16    
      LOGICAL LBL,LVD,LCR,LLR,LRD,LCUBM,LCBADJ,LSL,LOC                       PHYSCA.17    
     :       ,LNOICE,LOLDBL,LCOND,LNNSK                                      PHYSCA.18    
C                                                                            PHYSCA.19    
C                                                                            BATS.2     
C     Constant arrays and variables associated with time and vertical        BATS.3     
C     differencing. Also counters.                                           BATS.4     
C                                                                            BATS.5     
      COMMON/BATS/  BM1(IDE),AK(NNP),AQ(NL2),G(NL2),TAU(NL2)                 BATS.6     
     +              ,KOUNT,KITS,KSTART,KTOTAL,KRUN,BEGDAY,ITSPD              BATS.7     
     +              ,DELT,DELT2,CV,CG,CT,CQ,PNU,PNU2,PNU21                   BATS.8     
     +              ,NTRACO,CTRA(NTRAC),KOLOUR(NTRAC),RGG(NL2)               BATS.9     
     +              ,BEGDOY,DOY                                              BATS.10    
C                                                                            BATS.11    
       COMMON/CPIERS/ICFLAG(IGC,5,2),CFRAC(IGC,5),PNET(IGC,JG)               CPIERS.2     
     :               ,SNET(IGC,JG),RRFLUX(IGC,JG,6)                          CPIERS.3     
     :               ,TTSW(IGC,NL),TTLW(IGC,NL)                              CPIERS.4     
      REAL PL(NL),PSL(NL),PSK(NL),TSL(NL),TR(NL),QR(NL),CBC(NL),GH1(NL)      CBADJ.18    
C                                                                            XTRAP.2     
C     Setup moisture variables by equivilencing them to                      XTRAP.3     
C     Tracer No. 1                                                           XTRAP.4     
C                                                                            XTRAP.5     
      REAL QG(IGC,NL),QNLG(IGC,NL),QTLR(IGC,NL),QTCR(IGC,NL)                 XTRAP.6     
      EQUIVALENCE (QG(1,1),TRAG(1,1,1)) , (QNLG(1,1),TRANLG(1,1,1))          XTRAP.7     
     *            ,(QTLR(1,1),UTRAG(1,1,1)),(QTCR(1,1),VTRAG(1,1,1))         XTRAP.8     
C                                                                            XTRAP.9     
C*      2001 FORMAT(' CBADJ DEEP SWAP: I,J,NCRB,NCRT,QRINT,QGINT = '         CBADJ.20    
C*     F      ,4I5,2F10.4)                                                   CBADJ.21    
C                                                                            CBADJ.22    
C     Choose appropriate value of latent heat based on ground T              CBADJ.23    
c     ie, we assume it snows if the ground is colder than 273.15K            CBADJ.24    
      if (tstar(j,jh).gt.0.363224029) then                                   CBADJ.25    
         ctquse=ctq                                                          CBADJ.26    
      else                                                                   CBADJ.27    
         ctquse=ctqi                                                         CBADJ.28    
      endif                                                                  CBADJ.29    
      NLEV=1+NCRB-NCRT                                                       CBADJ.30    
      EPSIT=CTQUSE*EPSIQ                                                     CBADJ.31    
C                                                                            CBADJ.32    
      DO 10 L=NCRT,NCRB                                                      CBADJ.33    
        PL(L)=SIGMA(L)*PLG(J)                                                CBADJ.34    
        PSL(L)=PL(L)+CBADJP                                                  CBADJ.35    
        PSK(L)=(PSL(L)/PL(L))**AKAP                                          CBADJ.36    
        CBC(L)=CTQUSE*PSK(L)/PSL(L)                                          CBADJ.37    
        TSL(L)=TC(L)*PSK(L)                                                  CBADJ.38    
        QR(L)=PQSAT(TSL(L))/PSL(L)                                           CBADJ.39    
   10 CONTINUE                                                               CBADJ.40    
C                                                                            CBADJ.41    
      SINT=SSUM(NLEV,DSIGMA(NCRT),1)                                         CBADJ.42    
      TGINT=SDOT(NLEV,TG(J,NCRT),IGC,DSIGMA(NCRT),1)                         CBADJ.43    
      QGINT=SDOT(NLEV,QG(J,NCRT),IGC,DSIGMA(NCRT),1)                         CBADJ.44    
      TRINT=SDOT(NLEV,TC(NCRT),1,DSIGMA(NCRT),1)                             CBADJ.45    
      QRINT=SDOT(NLEV,QR(NCRT),1,DSIGMA(NCRT),1)                             CBADJ.46    
      HGINT=TGINT+CTQUSE*QGINT                                               CBADJ.47    
      DHL=(HGINT-TRINT-CTQUSE*QRINT)/SINT                                    CBADJ.48    
      DO 15 L=NCRT,NCRB                                                      CBADJ.49    
 15   GH1(L)=(TC(L)+CTQUSE*QR(L)+DHL)*PSK(L)                                 CBADJ.50    
C                                                                            CBADJ.51    
      NIT=0                                                                  CBADJ.52    
   20 NIT=NIT+1                                                              CBADJ.53    
      DTMAX=0.0                                                              CBADJ.54    
      DO 30 L=NCRT,NCRB                                                      CBADJ.55    
        QN=CBC(L)*PQSAT(TSL(L))                                              CBADJ.56    
        DTSL=(TSL(L)+QN-GH1(L))/(1.0+ESCONB*QN/(TSL(L)*TSL(L)))              CBADJ.57    
        DTMAX=MAX(ABS(DTSL),DTMAX)                                           CBADJ.58    
        TSL(L)=TSL(L)-DTSL                                                   CBADJ.59    
   30 CONTINUE                                                               CBADJ.60    
      IF(DTMAX.LT.EPSIT) GOTO 40                                             CBADJ.61    
      IF(NIT.GT.10) GOTO 40                                                  CBADJ.62    
      GOTO 20                                                                CBADJ.63    
   40 CONTINUE                                                               CBADJ.64    
C                                                                            CBADJ.65    
      DO 50 L=NCRT,NCRB                                                      CBADJ.66    
        TR(L)=TSL(L)/PSK(L)                                                  CBADJ.67    
        QR(L)=PQSAT(TSL(L))/PSL(L)                                           CBADJ.68    
   50 CONTINUE                                                               CBADJ.69    
C                                                                            CBADJ.70    
      QRINT=SDOT(NLEV,QR(NCRT),1,DSIGMA(NCRT),1)                             CBADJ.71    
      IF(QRINT.GT.QGINT) THEN                                                CBADJ.72    
C*      WRITE(2,2001) J,JH,NCRB,NCRT,CQ*QRINT/SINT,CQ*QGINT/SINT             CBADJ.73    
        IF(LCUBM)      CALL CUBM (NCRB,NCRT,J,IHEM)                          CBADJ.74    
        IF(.NOT.LCUBM) CALL CUDIF(NCRB,NCRT,J,IHEM)                          CBADJ.75    
      ELSE                                                                   CBADJ.76    
        TRINT=SDOT(NLEV,TR(NCRT),1,DSIGMA(NCRT),1)                           CBADJ.77    
        DHL=(HGINT-TRINT-CTQUSE*QRINT)/SINT                                  CBADJ.78    
        DO 60 L=NCRT,NCRB                                                    CBADJ.79    
          TR(L)=TR(L)+DHL                                                    CBADJ.80    
          TTEND=(TR(L)-TG(J,L))/CBADJT                                       CBADJ.81    
          QTEND=(QR(L)-QG(J,L))/CBADJT                                       CBADJ.82    
          TTMC(L)=TTMC(L)+TTEND                                              CBADJ.83    
          QTMC(L)=QTMC(L)+QTEND                                              CBADJ.84    
          TG(J,L)=TG(J,L)+DELT2C*TTEND                                       CBADJ.85    
          QG(J,L)=QG(J,L)+DELT2C*QTEND                                       CBADJ.86    
          CTCR(L,IHEM)=CTCR(L,IHEM)+1.0                                      CBADJ.87    
   60   CONTINUE                                                             CBADJ.88    
        CTCR(NCRB,IHEM)=CTCR(NCRB,IHEM)-1.0                                  CBADJ.89    
        RRCR(J)=RRCR(J)-RCON*PLG(J)*(QRINT-QGINT)/CBADJT                     CBADJ.90    
C deep convection parameterised by precip.:  P is mm/day                     CBADJ.91    
        P=-REAL(ITSPD)*RCON*PLG(J)*(QRINT-QGINT)/CBADJT                      CBADJ.92    
        IF (P.GT.0.15) THEN                                                  CBADJ.93    
          CFRAC(J,5)=0.245+0.125*LOG(P)                                      CBADJ.94    
          CFRAC(J,5)=MIN(1.0,CFRAC(J,5))                                     CBADJ.95    
          ICFLAG(J,5,1)=NCRB                                                 CBADJ.96    
          ICFLAG(J,5,2)=NCRT                                                 CBADJ.97    
        ENDIF                                                                CBADJ.98    
      ENDIF                                                                  CBADJ.99    
C                                                                            CBADJ.100   
      RETURN                                                                 CBADJ.101   
      END                                                                    CBADJ.102   
